diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
index 07c83dbfb..8d08c9732 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
@@ -196,7 +196,7 @@ public class EntityFishingBobber extends Entity
             }
         }
         if (isInGround()) {
-            if (world.getBlockId(xTile, yTile, zTile) == Blocks.ROPE.id) {
+            if (world.getBlockId(xTile, yTile, zTile) == Blocks.ROPE.id()) {
                 x = xTile + 0.5D;
                 y = yTile + 0.5D;
                 z = zTile + 0.5D;
@@ -219,7 +219,7 @@ public class EntityFishingBobber extends Entity
         if(clip != null)
         {
             nextPos = Vec3.getTempVec3(clip.location.x, clip.location.y, clip.location.z);
-            if (clip.hitType == HitResult.HitType.TILE && world.getBlockId(clip.x, clip.y, clip.z) == Blocks.ROPE.id) {
+            if (clip.hitType == HitResult.HitType.TILE && world.getBlockId(clip.x, clip.y, clip.z) == Blocks.ROPE.id()) {
                 setInGround(true);
                 xTile = clip.x;
                 yTile = clip.y;
@@ -305,7 +305,7 @@ public class EntityFishingBobber extends Entity
                     rainRate = 200;
                 }
 
-                if(world.getBlockId(MathHelper.floor(x), MathHelper.floor(y) + 1, MathHelper.floor(z)) == Blocks.ALGAE.id) {
+                if(world.getBlockId(MathHelper.floor(x), MathHelper.floor(y) + 1, MathHelper.floor(z)) == Blocks.ALGAE.id()) {
                     algaeRate = 100;
                 }
                 catchRate = (catchRate - rainRate) - algaeRate;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index 218c8ead2..cccec28aa 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -6,8 +6,8 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicLog;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockLog;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemDiscMusic;
@@ -17,6 +17,7 @@ import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class EntityItem extends Entity
 {
@@ -201,7 +202,8 @@ public class EntityItem extends Entity
 
 			if(item.stackSize < previousStackSize) {
 				if(item.itemID < 16384) {
-					if(Blocks.blocksList[item.itemID] instanceof BlockLog) {
+                    Block<?> b = Blocks.blocksList[item.itemID];
+					if(b != null && b.getLogic() instanceof BlockLogicLog) {
 						player.triggerAchievement(Achievements.MINE_WOOD);
 					}
 				}
@@ -214,7 +216,7 @@ public class EntityItem extends Entity
                 if(item.itemID == Items.NETHERCOAL.id) {
                     player.triggerAchievement(Achievements.GET_NETHERCOAL);
                 }
-				if(item.itemID == Blocks.ICE.id) {
+				if(item.itemID == Blocks.ICE.id()) {
 					player.triggerAchievement(Achievements.CRUSH_BLOCKS);
 				}
 				
@@ -262,26 +264,25 @@ public class EntityItem extends Entity
 
     public void clumpToNearbyStack() {
     	AABB boundingBox = this.bb.grow(0.5, 0.0, 0.5);
-    	List<Entity> entities = world.getEntitiesWithinAABB(EntityItem.class, boundingBox);
+    	List<@NotNull EntityItem> entities = world.getEntitiesWithinAABB(EntityItem.class, boundingBox);
     	
-    	for(Entity otherEntity : entities) {
-    		if(otherEntity == this || !(otherEntity instanceof EntityItem) || !otherEntity.isAlive() || !this.isAlive()) {
+    	for(EntityItem otherEntity : entities) {
+    		if(otherEntity == this || !otherEntity.isAlive() || !this.isAlive()) {
     			continue;
     		}
-    		EntityItem otherEntityItem = (EntityItem) otherEntity;
-    		
-    		ItemStack thisItemStack = this.item;
-    		ItemStack otherItemStack = otherEntityItem.item;
+
+            ItemStack thisItemStack = this.item;
+    		ItemStack otherItemStack = otherEntity.item;
     		
-    		if(this.item.canStackWith(otherEntityItem.item)) {
+    		if(this.item.canStackWith(otherEntity.item)) {
     			if(thisItemStack.stackSize + otherItemStack.stackSize > 64) {
     				continue;
     			}
     			
     			if(otherItemStack.stackSize > thisItemStack.stackSize) {
-    				combineItems(otherEntityItem, this);
+    				combineItems(otherEntity, this);
     			}else {
-    				combineItems(this, otherEntityItem);
+    				combineItems(this, otherEntity);
     			}
     		}
     	}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
index 7eb092cea..037fa0d1e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -58,7 +58,7 @@ public class EntityLightning extends Entity
                     int k = MathHelper.floor(z);
                     if(world.getBlockId(i, j, k) == 0 && Blocks.FIRE.canPlaceBlockAt(world, i, j, k))
                     {
-                        world.setBlockWithNotify(i, j, k, Blocks.FIRE.id);
+                        world.setBlockWithNotify(i, j, k, Blocks.FIRE.id());
                     }
                 }
             }
@@ -90,7 +90,7 @@ public class EntityLightning extends Entity
             int i1 = MathHelper.floor(z);
             if(world.getBlockId(i, k, i1) == 0 && Blocks.FIRE.canPlaceBlockAt(world, i, k, i1))
             {
-                world.setBlockWithNotify(i, k, i1, Blocks.FIRE.id);
+                world.setBlockWithNotify(i, k, i1, Blocks.FIRE.id());
             }
             for(int j = 0; j < 4; j++)
             {
@@ -99,7 +99,7 @@ public class EntityLightning extends Entity
                 int k1 = (MathHelper.floor(z) + random.nextInt(3)) - 1;
                 if(world.getBlockId(l, j1, k1) == 0 && Blocks.FIRE.canPlaceBlockAt(world, l, j1, k1))
                 {
-                    world.setBlockWithNotify(l, j1, k1, Blocks.FIRE.id);
+                    world.setBlockWithNotify(l, j1, k1, Blocks.FIRE.id());
                 }
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index b23d62aab..f0b2abdcc 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -159,7 +159,6 @@ public abstract class Mob extends Entity
 
     @Override
 	public String getEntityTexture() {
-        SkinVariantList variantList = Global.accessor.getSkinVariantList();
         String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
         return basePath + getTextureReference() + ".png";
     }
@@ -652,7 +651,7 @@ public abstract class Mob extends Entity
         {
             return String.format("%s%s swam in lava.", name, deathMsgColor);
         }
-        if (world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Blocks.SPIKES.id)
+        if (world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) == Blocks.SPIKES.id())
         {
             return String.format("%s%s got impaled.", name, deathMsgColor);
         }
@@ -767,7 +766,7 @@ public abstract class Mob extends Entity
             int blockX = MathHelper.floor(x);
             int blockY = MathHelper.floor(y - heightOffset);
             int blockZ = MathHelper.floor(z);
-            Block b = world.getBlock(blockX, blockY, blockZ);
+            Block<?> b = world.getBlock(blockX, blockY, blockZ);
             float depth = 0.6f;
             if (b != null) {
                 depth = 1 - (float) b.getBlockBoundsFromState(world, blockX, blockY, blockZ).maxY;
@@ -910,7 +909,7 @@ public abstract class Mob extends Entity
         int i = MathHelper.floor(x);
         int j = MathHelper.floor(bb.minY);
         int k = MathHelper.floor(z);
-        Block block = world.getBlock(i, j, k);
+        Block<?> block = world.getBlock(i, j, k);
         return block != null && block.isClimbable(world, i, j, k);
     }
 
@@ -968,16 +967,16 @@ public abstract class Mob extends Entity
             newPosRotationIncrements--;
             setPos(d, d1, d2);
             setRot(yRot, xRot);
-            List list1 = world.getCubes(this, bb.getInsetBoundingBox(0.03125D, 0.0D, 0.03125D));
-            if(list1.size() > 0)
+            List<AABB> list1 = world.getCubes(this, bb.getInsetBoundingBox(0.03125D, 0.0D, 0.03125D));
+            if(!list1.isEmpty())
             {
                 double d4 = 0.0D;
                 for(int j = 0; j < list1.size(); j++)
                 {
-                    AABB axisalignedbb = (AABB)list1.get(j);
-                    if(axisalignedbb.maxY > d4)
+                    AABB aabb = list1.get(j);
+                    if(aabb.maxY > d4)
                     {
-                        d4 = axisalignedbb.maxY;
+                        d4 = aabb.maxY;
                     }
                 }
 
@@ -1017,12 +1016,12 @@ public abstract class Mob extends Entity
         moveForward *= 0.98F;
         randomYawVelocity *= 0.9F;
         moveEntityWithHeading(moveStrafing, moveForward);
-        List list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(0.2D, 0.0D, 0.2D));
-        if(list != null && list.size() > 0)
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(0.2D, 0.0D, 0.2D));
+        if(list != null && !list.isEmpty())
         {
             for(int i = 0; i < list.size(); i++)
             {
-                Entity entity = (Entity)list.get(i);
+                Entity entity = list.get(i);
                 if(entity.isPushable())
                 {
                     entity.push(this);
@@ -1185,7 +1184,7 @@ public abstract class Mob extends Entity
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(bb.minY);
         int blockZ = MathHelper.floor(z);
-        if(Block.hasTag(world.getBlockId(blockX, blockY, blockZ), BlockTags.PREVENT_MOB_SPAWNS)) {
+        if(Blocks.hasTag(world.getBlockId(blockX, blockY, blockZ), BlockTags.PREVENT_MOB_SPAWNS)) {
         	return false;
         }
         return world.checkIfAABBIsClear(bb) && world.getCubes(this, bb).size() == 0 && !world.getIsAnyLiquid(bb);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java b/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
index 538b5a8bc..9691b3cfb 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
@@ -1,6 +1,5 @@
 package net.minecraft.core.entity;
 
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
index 3b10a9791..b3cf3e964 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
@@ -141,13 +141,13 @@ public abstract class MobPathfinder extends Mob
     }
 
     protected Entity getClosestFireflyToEntity (int x, int y, int z, float radius){
-        List<Entity> nearbyFireflies = world.getEntitiesWithinAABB(MobFireflyCluster.class, AABB.getTemporaryBB(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).grow(radius, 4D, radius));
+        List<MobFireflyCluster> nearbyFireflies = world.getEntitiesWithinAABB(MobFireflyCluster.class, AABB.getTemporaryBB(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).grow(radius, 4D, radius));
 
         double closestDistance = -1D;
-        Entity cluster = null;
+        MobFireflyCluster cluster = null;
         for(int i = 0; i < nearbyFireflies.size(); i++)
         {
-            Entity clusterInList = nearbyFireflies.get(i);
+            MobFireflyCluster clusterInList = nearbyFireflies.get(i);
             double currentDistance = clusterInList.distanceToSqr(x, y, z);
             if((radius < 0.0D || currentDistance < radius * radius) && (closestDistance == -1D || currentDistance < closestDistance))
             {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
index 28459fb84..65a54063d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobAnimal.java
@@ -7,7 +7,6 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.season.Seasons;
 
@@ -60,7 +59,7 @@ public abstract class MobAnimal extends MobPathfinder
     @Override
 	protected float getBlockPathWeight(int x, int y, int z)
     {
-        if(world.getBlockId(x, y - 1, z) == Blocks.GRASS.id)
+        if(world.getBlockId(x, y - 1, z) == Blocks.GRASS.id())
         {
             return 10F;
         } else
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index fa28fdcc4..e3b5637cd 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -1,7 +1,6 @@
 package net.minecraft.core.entity.animal;
 
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
@@ -12,6 +11,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
+import org.jetbrains.annotations.NotNull;
 
 import java.util.Collection;
 import java.util.HashMap;
@@ -360,7 +360,7 @@ public class MobFireflyCluster extends MobFlying
 	private void merge() {
 		slowUpdateCooldown = slowUpdateCooldownMax;
 		
-		List<Entity> nearbyFireflies = world.getEntitiesWithinAABB(getClass(), bb.grow(2, 2, 2));
+		List<@NotNull MobFireflyCluster> nearbyFireflies = world.getEntitiesWithinAABB(MobFireflyCluster.class, bb.grow(2, 2, 2));
 		int nearbyCount = nearbyFireflies.size();
 		
 		if(nearbyCount == 1) {
@@ -369,11 +369,10 @@ public class MobFireflyCluster extends MobFlying
 		}
 		
 		for(int i=0; i < nearbyCount; i++) {
-			Entity entity = nearbyFireflies.get(i);
-			if(entity == this || !(entity instanceof MobFireflyCluster)) {
+			MobFireflyCluster fireflyCluster = nearbyFireflies.get(i);
+			if(fireflyCluster == this) {
 				continue;
 			}
-			MobFireflyCluster fireflyCluster = (MobFireflyCluster) entity;
 			if(fireflyCluster.getColor() != this.getColor()) {
 				continue;
 			}
@@ -403,7 +402,7 @@ public class MobFireflyCluster extends MobFlying
 		setSizeBasedOnClusterSize(prevSize + 1);
 		setPos(x, y, z); // Update bounding box
 		
-		if(world.getCollidingSolidBlockBoundingBoxes(this, bb).size() == 0) {
+		if(world.getCollidingSolidBlockBoundingBoxes(this, bb).isEmpty()) {
 			setClusterSize(prevSize + 1);
 			return;
 		}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index b1e97986e..25fb24f0c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -2,7 +2,6 @@ package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.achievement.Achievements;
-import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.EntityLightning;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
index 110088d9f..77d962d46 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
@@ -50,7 +50,7 @@ public class MobSheep extends MobAnimal
         super.dropDeathItems();
         if(!getSheared())
         {
-            spawnAtLocation(new ItemStack(Blocks.WOOL.id, 1, getFleeceColor().blockMeta), 0.0F);
+            spawnAtLocation(new ItemStack(Blocks.WOOL.id(), 1, getFleeceColor().blockMeta), 0.0F);
         }
     }
     @Override
@@ -65,7 +65,7 @@ public class MobSheep extends MobAnimal
                     setSheared(true);
                     int count = 2 + random.nextInt(3);
                     for (int j = 0; j < count; j++) {
-                        EntityItem entityitem = spawnAtLocation(new ItemStack(Blocks.WOOL.id, 1, getFleeceColor().blockMeta), 1.0F);
+                        EntityItem entityitem = spawnAtLocation(new ItemStack(Blocks.WOOL.id(), 1, getFleeceColor().blockMeta), 1.0F);
                         entityitem.yd += random.nextFloat() * 0.05F;
                         entityitem.xd += (random.nextFloat() - random.nextFloat()) * 0.1F;
                         entityitem.zd += (random.nextFloat() - random.nextFloat()) * 0.1F;
@@ -87,7 +87,7 @@ public class MobSheep extends MobAnimal
                 setSheared(true);
                 int count = 2 + random.nextInt(3);
                 for (int j = 0; j < count; j++) {
-                    EntityItem entityItem = spawnAtLocation(new ItemStack(Blocks.WOOL.id, 1, getFleeceColor().blockMeta), 1.0F);
+                    EntityItem entityItem = spawnAtLocation(new ItemStack(Blocks.WOOL.id(), 1, getFleeceColor().blockMeta), 1.0F);
                     entityItem.yd += random.nextFloat() * 0.05F;
                     entityItem.xd += (random.nextFloat() - random.nextFloat()) * 0.1F;
                     entityItem.zd += (random.nextFloat() - random.nextFloat()) * 0.1F;
@@ -144,7 +144,7 @@ public class MobSheep extends MobAnimal
 			int blockX = MathHelper.floor(x);
 			int blockY = MathHelper.floor(y);
 			int blockZ = MathHelper.floor(z);
-			Block blockBelow = world.getBlock(blockX, blockY - 1, blockZ);
+            Block<?> blockBelow = world.getBlock(blockX, blockY - 1, blockZ);
 			
 			growthTimer = 0;
 			if (blockBelow == Blocks.GRASS || blockBelow == Blocks.GRASS_RETRO) {
@@ -161,7 +161,7 @@ public class MobSheep extends MobAnimal
 			int blockX = MathHelper.floor(x);
 			int blockY = MathHelper.floor(y);
 			int blockZ = MathHelper.floor(z);
-			Block blockBelow = world.getBlock(blockX, blockY - 1, blockZ);
+            Block<?> blockBelow = world.getBlock(blockX, blockY - 1, blockZ);
 			
 			if (timeSheepEating >= 5 && timeSheepEating <= 35 && timeSheepEating % 5 == 0 && !world.isClientSide) {
 				world.playBlockSoundEffect(null, x + 0.5, y + 0.5, z + 0.5, Blocks.GRASS, EnumBlockSoundEffectType.DIG);
@@ -173,7 +173,7 @@ public class MobSheep extends MobAnimal
 				if(blockBelow == Blocks.GRASS || blockBelow == Blocks.GRASS_RETRO) {
 					if(!world.isClientSide) {
 						world.playBlockEvent(null, LevelListener.EVENT_BLOCK_BREAK, (int) x, (int) y - 1, (int) z, world.getBlockId((int) x, (int) y - 1, (int) z));
-						world.setBlockWithNotify(blockX, blockY - 1, blockZ, Blocks.DIRT.id);
+						world.setBlockWithNotify(blockX, blockY - 1, blockZ, Blocks.DIRT.id());
 						setSheared(false);
 					}
 				}
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
index c586e6ab7..42dbead8a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
@@ -2,7 +2,6 @@ package net.minecraft.core.entity.animal;
 
 import net.minecraft.core.WeightedRandomLootObject;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Items;
@@ -170,17 +169,17 @@ public class MobSquid extends MobWaterAnimal
         {
             float f = random.nextFloat() * MathHelper.PI * 2.0F;
             tx = MathHelper.cos(f) * 0.2F;
-            Block upwardsBlock = world.getBlock((int) x, (int) y + 3, (int) z);
-            Block downwardsBlock = world.getBlock((int) x, (int) y - 3, (int) z);
+            Block<?> upwardsBlock = world.getBlock((int) x, (int) y + 3, (int) z);
+            Block<?> downwardsBlock = world.getBlock((int) x, (int) y - 3, (int) z);
 
             boolean isTouchingBlock = isTouchingBlock();
 
             if (isTouchingBlock && isInWater() && !world.isAirBlock((int) x, (int) (y + 1), (int) z) && !world.isAirBlock((int) x, (int) (y + 2), (int) z)){
                 ty = random.nextFloat() * 0.2F;
             } else {
-                if (upwardsBlock == null || upwardsBlock.blockMaterial != Material.water){
+                if (upwardsBlock == null || upwardsBlock.getMaterial() != Material.water){
                     ty = -0.15F + random.nextFloat() * 0.2F; // Swim with bias down
-                } else if (downwardsBlock == null || downwardsBlock.blockMaterial != Material.water) {
+                } else if (downwardsBlock == null || downwardsBlock.getMaterial() != Material.water) {
                     ty = -0.05F + random.nextFloat() * 0.4F; // Swim with bias up
                 } else {
                     ty = -0.1F + random.nextFloat() * 0.2F; // Swim with no bias
@@ -206,8 +205,8 @@ public class MobSquid extends MobWaterAnimal
                 {
                     for(int _z = minZ; _z <= maxZ; _z++)
                     {
-                        int blockId = world.getBlockId(_x, _y, _z);
-                        if(blockId != 0 && Blocks.blocksList[blockId].blockMaterial != Material.water)
+                        Block<?> block = world.getBlock(_x, _y, _z);
+                        if(block != null && block.getMaterial() != Material.water)
                         {
                             return true;
                         }
@@ -227,6 +226,6 @@ public class MobSquid extends MobWaterAnimal
     }
 
     public boolean isSpecial() {
-        return nickname != null && nickname.hashCode() == 678229435;
+        return "Useless7695".equals(nickname);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index 3bab971d1..b8b6b4bd7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -325,20 +325,20 @@ public class MobWolf extends MobAnimal
         if(target == null && !hasPath())
         {
             if(!isWolfTamed() && world.rand.nextInt(100) == 0){
-                List<Entity> nearbySheep = world.getEntitiesWithinAABB(MobSheep.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                List<MobSheep> nearbySheep = world.getEntitiesWithinAABB(MobSheep.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
                 if (!nearbySheep.isEmpty()) {
-                    setTarget((Entity) nearbySheep.get(world.rand.nextInt(nearbySheep.size())));
+                    setTarget(nearbySheep.get(world.rand.nextInt(nearbySheep.size())));
                 }
             }
         }
         ItemStack heldItemSlot = getWolfHeldItem();
         if((heldItemSlot == null || heldItemSlot.itemID <= 0)) {
-            List<Entity> triedItems = new ArrayList<>();
-            List<Entity> nearbyItems = world.getEntitiesWithinAABB(EntityItem.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+            List<EntityItem> triedItems = new ArrayList<>();
+            List<EntityItem> nearbyItems = world.getEntitiesWithinAABB(EntityItem.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
             if (!nearbyItems.isEmpty()) {
                 while (triedItems.size() != nearbyItems.size())
                 {
-                    EntityItem item = (EntityItem) nearbyItems.get(world.rand.nextInt(nearbyItems.size()));
+                    EntityItem item = nearbyItems.get(world.rand.nextInt(nearbyItems.size()));
                     if (triedItems.contains(item))
                     {
                         continue;
@@ -408,7 +408,7 @@ public class MobWolf extends MobAnimal
         super.tick();
 
         List<Entity> entitiesNearWolf = world.getEntitiesWithinAABBExcludingEntity(this, bb);
-        if(entitiesNearWolf != null && entitiesNearWolf.size() > 0 && isAlive())
+        if(entitiesNearWolf != null && !entitiesNearWolf.isEmpty() && isAlive())
         {
             for (Entity entity : entitiesNearWolf) {
                 if(entity instanceof EntityItem && (this.getWolfHeldItem() == null || this.getWolfHeldItem().getItem() == null)){
@@ -578,22 +578,21 @@ public class MobWolf extends MobAnimal
                 }
                 if(attacker instanceof Mob)
                 {
-                    List<Entity> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
-                    Iterator<Entity> iterator = list.iterator();
+                    List<MobWolf> list = world.getEntitiesWithinAABB(MobWolf.class, AABB.getTemporaryBB(x, y, z, x + 1.0D, y + 1.0D, z + 1.0D).grow(16D, 4D, 16D));
+                    Iterator<MobWolf> iterator = list.iterator();
                     do
                     {
                         if(!iterator.hasNext())
                         {
                             break;
                         }
-                        Entity entity1 = iterator.next();
-                        MobWolf entitywolf = (MobWolf)entity1;
-                        if(!entitywolf.isWolfTamed() && entitywolf.target == null)
+                        MobWolf mobWolf = iterator.next();
+                        if(!mobWolf.isWolfTamed() && mobWolf.target == null)
                         {
-                            entitywolf.target = attacker;
+                            mobWolf.target = attacker;
                             if(attacker instanceof Player)
                             {
-                                entitywolf.setWolfAngry(true);
+                                mobWolf.setWolfAngry(true);
                             }
                         }
                     } while(true);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
index cd0a55f6e..2d2c333f8 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSnowman.java
@@ -52,7 +52,7 @@ public class MobSnowman extends MobMonster
             {
                 if(!world.isClientSide) {
                     ProjectileSnowball projectileSnowball = new ProjectileSnowball(world, this);
-                    if (world.getBlockId((int) x, (int) y - 1, (int) z) == Blocks.GRAVEL.id)
+                    if (world.getBlockId((int) x, (int) y - 1, (int) z) == Blocks.GRAVEL.id())
                     {
                         projectileSnowball.damage = 1;
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
index 970af73a8..1e6c85ec7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombiePig.java
@@ -63,11 +63,11 @@ public class MobZombiePig extends MobZombie
     	int y = MathHelper.floor(this.y);
     	int z = MathHelper.floor(this.z);
     	if(world.getBlockId(x, y, z) != 0) return false;
-        Block below = world.getBlock(x, y - 1, z);
+        Block<?> below = world.getBlock(x, y - 1, z);
         if (!BlockTags.NETHER_MOBS_SPAWN.appliesTo(below)) return false;
         int blockLight = world.getSavedLightValue(LightLayer.Block, x, y, z);
     	if(blockLight > 7) return false;
-        return world.getDifficulty().canHostileMobsSpawn() && world.checkIfAABBIsClear(bb) && world.getCubes(this, bb).size() == 0 && !world.getIsAnyLiquid(bb);
+        return world.getDifficulty().canHostileMobsSpawn() && world.checkIfAABBIsClear(bb) && world.getCubes(this, bb).isEmpty() && !world.getIsAnyLiquid(bb);
     }
 
     @Override
@@ -104,14 +104,14 @@ public class MobZombiePig extends MobZombie
     	}
         if(attacker instanceof Player)
         {
-            List list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(32D, 32D, 32D));
+            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.grow(32D, 32D, 32D));
             for(int j = 0; j < list.size(); j++)
             {
-                Entity entity1 = (Entity)list.get(j);
-                if(entity1 instanceof MobZombiePig)
+                Entity e = list.get(j);
+                if(e instanceof MobZombiePig)
                 {
-                    MobZombiePig entitypigzombie = (MobZombiePig)entity1;
-                    entitypigzombie.becomeAngryAt(attacker);
+                    MobZombiePig mobZombiePig = (MobZombiePig)e;
+                    mobZombiePig.becomeAngryAt(attacker);
                 }
             }
 
